Extern "Win32"
	Function GetWindowDC:Int( hwnd:Int )
	Function ReleaseDC:Int( hwnd:Int, hdc:Int )
	Function CreateBitmap:Int( width:Int, height:Int, planes:Int, bits:Int, pixel:Byte Ptr )
	Function TextOutA:Int( hdc:Int, x:Int, y:Int, text:Byte Ptr, count:Int )
	Function MulDiv:Int( number:Int, nominator:Int, denominator:Int )
	Function GetSystemMetrics:Int( index:Int )
End Extern

Global gdi:Int, dwm:Int, com:Int

Global GdiplusStartup:Int( token:Int Ptr, in:Byte Ptr, out:Byte Ptr ) "Win32"
Global GdiplusShutdown( token:Int Ptr ) "Win32"
Global GdipCreateFromHDC:Int( hdc:Int, graph:Byte Ptr Ptr ) "Win32"
Global GdipDeleteGraphics:Int( graph:Byte Ptr ) "Win32"
Global GdipCreateSolidFill:Int( color:Int, brush:Byte Ptr Ptr ) "Win32"
Global GdipDeleteBrush:Int( brush:Byte Ptr ) "Win32"
Global GdipFillRectangle:Int( graph:Byte Ptr, brush:Byte Ptr, x:Int, y:Int, width:Int, height:Int ) "Win32"
Global GdipLoadImageFromFile:Int( filename$w, image:Byte Ptr Ptr ) "Win32"
Global GdipDrawImageRect:Int( graph:Byte Ptr, image:Byte Ptr, x:Int, y:Int, w:Int, h:Int ) "Win32"

Global ExtendFrame:Int( hwnd:Int, margins:Int Ptr ) "Win32"
Global DwmIsCompositionEnabled:Int( enabled:Int Ptr ) "Win32"

Global SetWindowSubclass:Int( hwnd:Int, proc:Byte Ptr, id:Int Ptr, ref:TGlassWindow ) "Win32"
Global DefSubclassProc:Int( hwnd:Int, msg:Int, wparam:Int, lparam:Int ) "Win32"

Function LoadLibraries:Int( )	
	gdi = LoadLibraryA( "gdiplus.dll" )
	dwm = LoadLibraryA( "dwmapi.dll" )
	com = LoadLibraryA( "comctl32.dll" )
	
	If Not gdi Return 1
	If Not dwm Return 2
	If Not com Return 1
	
	Return 0
End Function

Function LoadFunctions:Int( )

	If gdi
		GdiplusStartup = GetProcAddress( gdi, "GdiplusStartup" )
		GdiplusShutdown = GetProcAddress( gdi, "GdiplusShutdown" )
		GdipCreateFromHDC = GetProcAddress( gdi, "GdipCreateFromHDC" )
		GdipDeleteGraphics = GetProcAddress( gdi, "GdipDeleteGraphics" )
		GdipCreateSolidFill = GetProcAddress( gdi, "GdipCreateSolidFill" )
		GdipDeleteBrush = GetProcAddress( gdi, "GdipDeleteBrush" )
		GdipFillRectangle = GetProcAddress( gdi, "GdipFillRectangleI" )
		GdipLoadImageFromFile = GetProcAddress( gdi, "GdipLoadImageFromFile" )
		GdipDrawImageRect = GetProcAddress( gdi, "GdipDrawImageRectI" )
	End If
	
	If dwm
		ExtendFrame = GetProcAddress( dwm, "DwmExtendFrameIntoClientArea" )
		DwmIsCompositionEnabled = GetProcAddress( dwm, "DwmIsCompositionEnabled" )
	End If
	
	If com
		SetWindowSubclass = GetProcAddress( com, "SetWindowSubclass" )
		DefSubclassProc = GetProcAddress( com, "DefSubclassProc" )
	End If
	
	Return 1
End Function
