
'
' ChristianK's Terminplaner
' Programmiert fr den BCC 13
'
' Bentigt MaxGUI, um kompiliert werden zu knnen
'

SuperStrict

Framework brl.blitz
Import brl.eventqueue
Import brl.stream
Import brl.retro
Import pub.win32
Import maxgui.win32maxguiex

Include "libraries.bmx"

'
' Type fr Glasfenster und Manager fr globale Objekte
'

Type TGlassManager
	Global font_title:Int
	Global composition:Int
	Global vista:Int
	
	Function Init:Int( )
		font_title = CreateFontA( -MulDiv( 12, GetDeviceCaps( 0, LOGPIXELSY ), 72 ), 0, 0, 0, 400, 0, 0, 0, 1, 0, 0, CLEARTYPE_QUALITY, 0, "Tahoma" )
		
		If vista
			DwmIsCompositionEnabled( Varptr composition )
		End If
		
		Return 1
	End Function

End Type

Type TGlassWindow
	Global subid_counter:Int
	
	Field gadget:TGadget, hwnd:Int
	Field subid:Int
	Field bitmap:Int, dc:Int, brush:Int
	Field glass_top:Int, glass_bottom:Int
	
	Method Init:TGlassWindow( width:Int, height:Int, gtop:Int, gbottom:Int, parent:TGadget = Null )
		
		'
		' Mae berechnen und Fenster-Gadget erstellen
		'
		
		Local desk:TGadget = Desktop( )
		Local x:Int = desk.width/2 - width/2
		Local y:Int = desk.height/2 - height/2
		
		gadget = CreateWindow( Null, x, y, width, height, parent, WINDOW_CLIENTCOORDS | WINDOW_TITLEBAR | WINDOW_HIDDEN )
		
		hwnd = QueryGadget( gadget, QUERY_HWND )
		
		'
		' Fr Aero Glass ntige Styles einstellen
		'
		
		SetWindowLongA( hwnd, GWL_EXSTYLE, WS_EX_COMPOSITED )
		SetWindowLongA( hwnd, GWL_STYLE, WS_CAPTION )
		
		'
		' Frame ( Glasbereich ) erweitern
		'
		
		glass_top = gtop
		glass_bottom = gbottom
		
		If TGlassManager.vista
			Local margins:Int[] = [ 0, 0, gtop, gbottom ]
			ExtendFrame( hwnd, margins )
		End If
		
		'
		' Device Context und Bitmap fr Hintergrund erstellen
		'
		
		dc = CreateCompatibleDC( 0 )
		bitmap = CreateBitmap( width, height, 1, 32, Null )
		
		SelectObject( dc, bitmap )
		
		' Wenn Composition aus oder XP, Hintergrund grau zeichnen
		If Not TGlassManager.composition
			FillRect( dc, [ 0, 0, width, height ], CreateSolidBrush( $aaaaaa ) )
		End If
		
		Local rect:Int[]
		
		If gtop > -1 And gbottom > -1
			rect = [ 0, gtop, width, height-gbottom ]
			FillRect( dc, rect, GetStockObject( WHITE_BRUSH ) )
		End If
		
		'
		' Fenster subclassen, um Windows-Nachrichten bearbeiten zu knnen
		'
		
		subid_counter = subid_counter + 1
		
		subid = subid_counter
		SetWindowSubclass( hwnd, WindowProc, Varptr subid, Self )
		
		Return Self
	End Method
	
	Method DrawBitmap:Int( filename:String, x:Int, y:Int, w:Int, h:Int )
		
		'
		' Bitmap laden
		'	
		
		Local g:Byte Ptr, img:Byte Ptr
		GdipCreateFromHDC( dc, Varptr g )
		
		GdipLoadImageFromFile( filename, Varptr img )
		GdipDrawImageRect( g, img, x, y, w, h )
		
		GdipDeleteGraphics( g )
		
	End Method
	
	Method DrawString:Int( text:String, x:Int, y:Int )
		SelectObject( dc, TGlassManager.font_title )
		
		SetTextColor( dc, $963200 )
		TextOutA( dc, x, y, text, Len( text ) )
	End Method
End Type

'
' Subclassing-Funktion fr alle Aero-Fenster
'

Global PrevWindowProc:Byte Ptr

Function WindowProc:Int( hwnd:Int, msg:Int, wparam:Int, lparam:Int, id:Int Ptr, ref:TGlassWindow ) "Win32"

	'
	' Nachrichten auswerten, die nicht von MaxGUI behandelt werden
	'
	Select msg
		
		'
		' Ermglicht das Draggen des Fensters im Client-Bereich
		'
		Case WM_NCHITTEST
			Local rect:Int[4]
			GetWindowRect( hwnd, rect )
			
			Local caption:Int = GetSystemMetrics( 4 )
			
			Local x:Int = ( ( lparam & $FFFF ) - rect[0] )
			Local y:Int = ( ( ( lparam Shr 16 ) & $FFFF ) - rect[1] )
			
			If y < ref.glass_top + caption Return 2 Else Return 0
			
		'
		' Kopiert den Inhalt des Device Context auf das Fenster
		'
		Case $0014
			BitBlt( wparam, 0, 0, 500, 500, ref.dc, 0, 0, $00CC0020 )
			Return 1
			
	End Select
	
	'
	' Nchste Funktion der Subclass-Chain aufrufen
	'
	Return DefSubclassProc( hwnd, msg, wparam, lparam )
End Function

'
' Funktionen zum ermitteln des Datums
'

Function GetDay:Int( )
	Return Int( Mid( CurrentDate( ), 1, 2 ) )
End Function

Function GetMonth:Int( )
	Local month:String = Mid( CurrentDate( ), 4, 3 )
	
	Select month
		Case "Jan" Return 1
		Case "Feb" Return 2
		Case "Mar" Return 3
		Case "Apr" Return 4
		Case "May" Return 5
		Case "Jun" Return 6
		Case "Jul" Return 7
		Case "Aug" Return 8
		Case "Sep" Return 9
		Case "Oct" Return 10
		Case "Nov" Return 11
		Case "Dec" Return 12
	End Select
End Function

Function GetYear:Int( )
	Return Int( Mid( CurrentDate( ), 8, 4 ) )
End Function

'
' Bibliotheken und Funktionen laden
'

Local libs:Int = LoadLibraries( )

Select libs
	Case 0
		TGlassManager.vista = 1
		
	Case 1
		End
		
	Case 2
		TGlassManager.vista = 0
End Select

LoadFunctions( )

'
' GDI+ initialisieren
'

Global gdip_token:Int
Global gdip_in:Int[] = [ 1, 0, 0, 0 ]

GdiplusStartup( Varptr gdip_token, gdip_in, Null )

'
' Globale Daten fr Glasfenster laden
'

TGlassManager.Init( )

'
' Speicher fr Eintrge
'

Type TTermin
	Field desc:String, note:String
	Field day:Int, month:Int, year:Int
	Field rday:Int, rmonth:Int, ryear:Int
End Type

Global termin_array:TTermin[]
Global termin_count:Int
Global termin_mode:Int

'
' Entfernt einen Termin aus dem Termin-Array
'

Function RemoveTermin:Int( index:Int )
	termin_array = termin_array[ 0..index ] + termin_array[ index+1.. ]
	termin_count = termin_count - 1
	
	Return 1
End Function

'
' Fgt einen Termin zur Liste hinzu
'

Function AddTermin:Int( desc:String, note:String, day:Int, month:Int, year:Int, rday:Int, rmonth:Int, ryear:Int )
	Local date:String = day + ". " + month + ". " + year
	Local rdate:String = rday + ". " + rmonth + ". " + ryear
	
	AddGadgetItem( termine, desc, 0, -1, "Datum: " + date + " - Erinnern am: " + rdate )
	
	termin_array = termin_array[ ..termin_count + 1 ]
	termin_array[ termin_count ] = New TTermin
	termin_array[ termin_count ].desc = desc
	termin_array[ termin_count ].note = note
	termin_array[ termin_count ].day = day ; termin_array[ termin_count ].month = month ; termin_array[ termin_count ].year = year
	termin_array[ termin_count ].rday = rday ; termin_array[ termin_count ].rmonth = rmonth ; termin_array[ termin_count ].ryear = ryear
	
	termin_count = termin_count + 1
	
	Return 1
End Function

'
' ndert oder aktualisiert einen Termin
'

Function ModifyTermin:Int( item:Int, desc:String, note:String, day:Int, month:Int, year:Int, rday:Int, rmonth:Int, ryear:Int )
	Local date:String = day + ". " + month + ". " + year
	Local rdate:String = rday + ". " + rmonth + ". " + ryear
	
	ModifyGadgetItem( termine, item, desc, 0, -1, "Datum: " + date + " - Erinnern am: " + rdate )
	
	termin_array[ item ] = New TTermin
	termin_array[ item ].desc = desc
	termin_array[ item ].note = note
	termin_array[ item ].day = day ; termin_array[ item ].month = month ; termin_array[ item ].year = year
	termin_array[ item ].rday = rday ; termin_array[ item ].rmonth = rmonth ; termin_array[ item ].ryear = ryear
	
	Return 1
End Function

'
' Fenster erstellen
'

Include "interface.bmx"
	
'
' Termine laden und in Liste eintragen
'

Local file:TStream = ReadStream( "termine.dat" )
If file
	While Not Eof( file )
		Local len_desc:Int = ReadInt( file )
		Local desc:String = ReadString( file, len_desc )
		
		Local len_note:Int = ReadInt( file )
		Local note:String = ReadString( file, len_note )
		
		Local day:Int = ReadInt( file ), month:Int = ReadInt( file ), year:Int = ReadInt( file )
		Local rday:Int = ReadInt( file ), rmonth:Int = ReadInt( file ), ryear:Int = ReadInt( file )
		
		AddTermin( desc, note, day, month, year, rday, rmonth, ryear )
		
		' Wenn der heutige Tag dem Erinnerungsdatum entspricht, eine Meldung ausgeben
		If rday = GetDay( ) And rmonth = GetMonth( ) And ryear = GetYear( )
			SetGadgetText( lbl_note_termin, "Beschreibung: " + desc + "~n~nNotiz: " + note )
			ShowGadget( notewin.gadget )
		End If
	Wend
	
	CloseStream( file )
End If

If GadgetHidden( notewin.gadget ) ShowGadget( mainwin.gadget )

'
' Message Handler fr die Nachrichten-Auswertung
'

AddHook EmitEventHook, MessageHandler

Function MessageHandler:Object( id:Int, data:Object, context:Object )
	Local event:TEvent = TEvent( data )
	
	Select event.id
		Case EVENT_GADGETACTION
			Select event.source
			
				'
				' Neuer Termin
				'
				
				Case btn_add
					SetGadgetText( txt_desc, "" )
					SetGadgetText( txt_note, "" )
					SetGadgetText( txt_day, GetDay( ) ) ; SetGadgetText( txt_month, GetMonth( ) ) ; SetGadgetText( txt_year, GetYear( ) )
					SetGadgetText( txt_rday, GetDay( ) ) ; SetGadgetText( txt_rmonth, GetMonth( ) ) ; SetGadgetText( txt_ryear, GetYear( ) )
					
					termin_mode = 1
					ShowGadget( createwin.gadget )
					
				'
				' Termin bearbeiten
				'
				
				Case btn_mod
					Local item:Int = SelectedGadgetItem( termine )
					
					If item > -1
						SetGadgetText( txt_desc, termin_array[ item ].desc )
						SetGadgetText( txt_note, termin_array[ item ].note )
						SetGadgetText( txt_day, termin_array[ item ].day ) ; SetGadgetText( txt_month, termin_array[ item ].month ) ; SetGadgetText( txt_year, termin_array[ item ].year )
						SetGadgetText( txt_rday, termin_array[ item ].rday ) ; SetGadgetText( txt_rmonth, termin_array[ item ].rmonth ) ; SetGadgetText( txt_ryear, termin_array[ item ].ryear )
					
						termin_mode = 2
						ShowGadget( createwin.gadget )
					End If
					
				'
				' Termin lschen
				'
				
				Case btn_del
					Local item:Int = SelectedGadgetItem( termine )
					If item > -1
						RemoveGadgetItem( termine, item )
						
						RemoveTermin( item )
					End If
					
				'
				' Ok ( Termin einfgen )
				'
				
				Case btn_ok
					Local desc:String = TextFieldText( txt_desc )
					If Not desc Return Null
					
					Local note:String = TextFieldText( txt_note )
										
					Local day:Int = Int( TextFieldText( txt_day ) ), month:Int = Int( TextFieldText( txt_month ) ), year:Int = Int( TextFieldText( txt_year ) )
					Local rday:Int = Int( TextFieldText( txt_rday ) ), rmonth:Int = Int( TextFieldText( txt_rmonth ) ), ryear:Int = Int( TextFieldText( txt_ryear ) )
					
					If termin_mode = 1
						AddTermin( desc, note, day, month, year, rday, rmonth, ryear )
						Else
						ModifyTermin( SelectedGadgetItem( termine ), desc, note, day, month, year, rday, rmonth, ryear )
					End If
					
					HideGadget( createwin.gadget )
				
				'	
				' Abbrechen
				'
				
				Case btn_cancel
					HideGadget( createwin.gadget )
				
				'	
				' Programm beenden
				'
				
				Case btn_end
				
					' Termine in Datei schreiben
					Local file:TStream = WriteStream( "termine.dat" )
					If Not file End
					
					For Local I:Int = 0 To termin_count - 1
						WriteInt( file, Len( termin_array[I].desc ) )
						WriteString( file, termin_array[I].desc )
						
						WriteInt( file, Len( termin_array[I].note ) )
						WriteString( file, termin_array[I].note )
						
						WriteInt( file, termin_array[I].day ) ; WriteInt( file, termin_array[I].month ) ; WriteInt( file, termin_array[I].year )
						WriteInt( file, termin_array[I].rday ) ; WriteInt( file, termin_array[I].rmonth ) ; WriteInt( file, termin_array[I].ryear )
					Next
					
					CloseStream( file )
					
					' GDI+ beenden
					GdiplusShutdown( Varptr gdip_token )
					
					' Programm beenden
					End
					
				'
				' Okay im Erinnerungs-Fenster
				'
				
				Case btn_note_ok
					HideGadget( notewin.gadget )
					Delay 500
					ShowGadget( mainwin.gadget )
					
			End Select
	End Select
End Function

'
' Hauptschleife, die auf Events wartet
'

While True
	WaitEvent( )
Wend
